/*************************************************
* Session Cache Header File                      *
* (C) 2004-2006 Jack Lloyd                       *
*************************************************/

#ifndef AJISAI_SESSION_CACHE_H__
#define AJISAI_SESSION_CACHE_H__

#include <ajisai/types.h>
#include <vector>

namespace Ajisai {

/*************************************************
* Session Cache                                  *
*************************************************/
class Session_Cache
   {
   public:
      struct Session_Info
         {
         public:
            SecureVector<byte> master_key;
            u16bit ciphersuite;
            void* extra;
            Session_Info() { ciphersuite = 0; extra = 0; }
         };

      void add_session(const MemoryRegion<byte>&, const Session_Info&);
      Session_Info get_session(const MemoryRegion<byte>&) const;

      void delete_session(const MemoryRegion<byte>&);
      bool have_session(const MemoryRegion<byte>&);

      Session_Cache();
      ~Session_Cache();
   private:
      std::map<const MemoryVector<byte>, Session_Info> sessions;
   };

}

#endif
