/*************************************************
* TLS Connection Header File                     *
* (C) 2004-2006 Jack Lloyd                       *
*************************************************/

#ifndef AJISAI_CONNECTION_H__
#define AJISAI_CONNECTION_H__

#include <ajisai/types.h>
#include <vector>

namespace Ajisai {

/*************************************************
* TLS Connection                                 *
*************************************************/
class TLS_Connection
   {
   public:
      virtual u32bit read(byte[], u32bit) = 0;
      virtual void write(const byte[], u32bit) = 0;
      u32bit read(byte& in) { return read(&in, 1); }
      void write(byte out) { write(&out, 1); }

      virtual std::vector<X509_Certificate> peer_cert_chain() const = 0;

      virtual void close() = 0;

      virtual ~TLS_Connection() {}
   };

}

#endif
