/*
* TLS Handshake Hash Source File
* (C) 2004-2006 Jack Lloyd
*/

#ifndef AJISAI_HANDSHAKE_HASH__
#define AJISAI_HANDSHAKE_HASH__

#include <botan/secmem.h>

namespace Ajisai {

using namespace Botan;

/**
* TLS Handshake Hash
*/
class HandshakeHash
   {
   public:
      void update(const byte in[], u32bit length)
         { data.append(in, length); }
      void update(const MemoryRegion<byte>& in)
         { update(in.begin(), in.size()); }
      void update(byte in)
         { update(&in, 1); }

      SecureVector<byte> final();
      SecureVector<byte> final_ssl3(const MemoryRegion<byte>&);
   private:
      SecureVector<byte> data;
   };

}

#endif
